/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type {
  FunctionFragment,
  Result,
  EventFragment,
} from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
} from "../common";

export interface CrossChainBridgeInterface extends utils.Interface {
  functions: {
    "ERC20Token()": FunctionFragment;
    "_checkSign(uint256,address,uint128,uint8,bytes32,bytes32)": FunctionFragment;
    "checkSign(uint256,address,uint128,uint8,bytes32,bytes32)": FunctionFragment;
    "otherChainERC20Token()": FunctionFragment;
    "otherChainID()": FunctionFragment;
    "redeem(uint256,address,uint128,uint8,bytes32,bytes32)": FunctionFragment;
    "swap(uint128)": FunctionFragment;
    "validator()": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "ERC20Token"
      | "_checkSign"
      | "checkSign"
      | "otherChainERC20Token"
      | "otherChainID"
      | "redeem"
      | "swap"
      | "validator"
  ): FunctionFragment;

  encodeFunctionData(
    functionFragment: "ERC20Token",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "_checkSign",
    values: [
      BigNumberish,
      string,
      BigNumberish,
      BigNumberish,
      BytesLike,
      BytesLike
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "checkSign",
    values: [
      BigNumberish,
      string,
      BigNumberish,
      BigNumberish,
      BytesLike,
      BytesLike
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "otherChainERC20Token",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "otherChainID",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "redeem",
    values: [
      BigNumberish,
      string,
      BigNumberish,
      BigNumberish,
      BytesLike,
      BytesLike
    ]
  ): string;
  encodeFunctionData(functionFragment: "swap", values: [BigNumberish]): string;
  encodeFunctionData(functionFragment: "validator", values?: undefined): string;

  decodeFunctionResult(functionFragment: "ERC20Token", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "_checkSign", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "checkSign", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "otherChainERC20Token",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "otherChainID",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "redeem", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "swap", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "validator", data: BytesLike): Result;

  events: {
    "SwapExecuted(address,uint128)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "SwapExecuted"): EventFragment;
}

export interface SwapExecutedEventObject {
  receiver: string;
  amount: BigNumber;
}
export type SwapExecutedEvent = TypedEvent<
  [string, BigNumber],
  SwapExecutedEventObject
>;

export type SwapExecutedEventFilter = TypedEventFilter<SwapExecutedEvent>;

export interface CrossChainBridge extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: CrossChainBridgeInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    ERC20Token(overrides?: CallOverrides): Promise<[string]>;

    _checkSign(
      nonce: BigNumberish,
      receiver: string,
      amount: BigNumberish,
      v: BigNumberish,
      r: BytesLike,
      s: BytesLike,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    checkSign(
      nonce: BigNumberish,
      receiver: string,
      amount: BigNumberish,
      v: BigNumberish,
      r: BytesLike,
      s: BytesLike,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    otherChainERC20Token(overrides?: CallOverrides): Promise<[string]>;

    otherChainID(overrides?: CallOverrides): Promise<[BigNumber]>;

    redeem(
      nonce: BigNumberish,
      receiver: string,
      amount: BigNumberish,
      v: BigNumberish,
      r: BytesLike,
      s: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    swap(
      amount: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    validator(overrides?: CallOverrides): Promise<[string]>;
  };

  ERC20Token(overrides?: CallOverrides): Promise<string>;

  _checkSign(
    nonce: BigNumberish,
    receiver: string,
    amount: BigNumberish,
    v: BigNumberish,
    r: BytesLike,
    s: BytesLike,
    overrides?: CallOverrides
  ): Promise<boolean>;

  checkSign(
    nonce: BigNumberish,
    receiver: string,
    amount: BigNumberish,
    v: BigNumberish,
    r: BytesLike,
    s: BytesLike,
    overrides?: CallOverrides
  ): Promise<boolean>;

  otherChainERC20Token(overrides?: CallOverrides): Promise<string>;

  otherChainID(overrides?: CallOverrides): Promise<BigNumber>;

  redeem(
    nonce: BigNumberish,
    receiver: string,
    amount: BigNumberish,
    v: BigNumberish,
    r: BytesLike,
    s: BytesLike,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  swap(
    amount: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  validator(overrides?: CallOverrides): Promise<string>;

  callStatic: {
    ERC20Token(overrides?: CallOverrides): Promise<string>;

    _checkSign(
      nonce: BigNumberish,
      receiver: string,
      amount: BigNumberish,
      v: BigNumberish,
      r: BytesLike,
      s: BytesLike,
      overrides?: CallOverrides
    ): Promise<boolean>;

    checkSign(
      nonce: BigNumberish,
      receiver: string,
      amount: BigNumberish,
      v: BigNumberish,
      r: BytesLike,
      s: BytesLike,
      overrides?: CallOverrides
    ): Promise<boolean>;

    otherChainERC20Token(overrides?: CallOverrides): Promise<string>;

    otherChainID(overrides?: CallOverrides): Promise<BigNumber>;

    redeem(
      nonce: BigNumberish,
      receiver: string,
      amount: BigNumberish,
      v: BigNumberish,
      r: BytesLike,
      s: BytesLike,
      overrides?: CallOverrides
    ): Promise<void>;

    swap(amount: BigNumberish, overrides?: CallOverrides): Promise<void>;

    validator(overrides?: CallOverrides): Promise<string>;
  };

  filters: {
    "SwapExecuted(address,uint128)"(
      receiver?: null,
      amount?: null
    ): SwapExecutedEventFilter;
    SwapExecuted(receiver?: null, amount?: null): SwapExecutedEventFilter;
  };

  estimateGas: {
    ERC20Token(overrides?: CallOverrides): Promise<BigNumber>;

    _checkSign(
      nonce: BigNumberish,
      receiver: string,
      amount: BigNumberish,
      v: BigNumberish,
      r: BytesLike,
      s: BytesLike,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    checkSign(
      nonce: BigNumberish,
      receiver: string,
      amount: BigNumberish,
      v: BigNumberish,
      r: BytesLike,
      s: BytesLike,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    otherChainERC20Token(overrides?: CallOverrides): Promise<BigNumber>;

    otherChainID(overrides?: CallOverrides): Promise<BigNumber>;

    redeem(
      nonce: BigNumberish,
      receiver: string,
      amount: BigNumberish,
      v: BigNumberish,
      r: BytesLike,
      s: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    swap(
      amount: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    validator(overrides?: CallOverrides): Promise<BigNumber>;
  };

  populateTransaction: {
    ERC20Token(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    _checkSign(
      nonce: BigNumberish,
      receiver: string,
      amount: BigNumberish,
      v: BigNumberish,
      r: BytesLike,
      s: BytesLike,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    checkSign(
      nonce: BigNumberish,
      receiver: string,
      amount: BigNumberish,
      v: BigNumberish,
      r: BytesLike,
      s: BytesLike,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    otherChainERC20Token(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    otherChainID(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    redeem(
      nonce: BigNumberish,
      receiver: string,
      amount: BigNumberish,
      v: BigNumberish,
      r: BytesLike,
      s: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    swap(
      amount: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    validator(overrides?: CallOverrides): Promise<PopulatedTransaction>;
  };
}
